/**
 * Copyright (c) 2010 Mia-Software.
 *    All rights reserved. This program and the accompanying materials
 *    are made available under the terms of the Eclipse Public License v1.0
 *    which accompanies this distribution, and is available at
 *    http://www.eclipse.org/legal/epl-v10.html
 *    
 *    Contributors:
 *    
 *    	   Nicolas Guyomar (Mia-Software) - initial API and implementation
 */
package org.eclipse.modisco.jee.ejbjar.EjbJar20;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.modisco.jee.ejbjar.EjbJar20.EjbJar20Package
 * @generated
 */
public interface EjbJar20Factory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	EjbJar20Factory eINSTANCE = org.eclipse.modisco.jee.ejbjar.EjbJar20.impl.EjbJar20FactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Abstract Schema Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Abstract Schema Name Type</em>'.
	 * @generated
	 */
	AbstractSchemaNameType createAbstractSchemaNameType();

	/**
	 * Returns a new object of class '<em>Acknowledge Mode Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Acknowledge Mode Type</em>'.
	 * @generated
	 */
	AcknowledgeModeType createAcknowledgeModeType();

	/**
	 * Returns a new object of class '<em>Assembly Descriptor Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Assembly Descriptor Type</em>'.
	 * @generated
	 */
	AssemblyDescriptorType createAssemblyDescriptorType();

	/**
	 * Returns a new object of class '<em>Cascade Delete Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cascade Delete Type</em>'.
	 * @generated
	 */
	CascadeDeleteType createCascadeDeleteType();

	/**
	 * Returns a new object of class '<em>Cmp Field Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cmp Field Type</em>'.
	 * @generated
	 */
	CmpFieldType createCmpFieldType();

	/**
	 * Returns a new object of class '<em>Cmp Version Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cmp Version Type</em>'.
	 * @generated
	 */
	CmpVersionType createCmpVersionType();

	/**
	 * Returns a new object of class '<em>Cmr Field Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cmr Field Name Type</em>'.
	 * @generated
	 */
	CmrFieldNameType createCmrFieldNameType();

	/**
	 * Returns a new object of class '<em>Cmr Field Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cmr Field Type</em>'.
	 * @generated
	 */
	CmrFieldType createCmrFieldType();

	/**
	 * Returns a new object of class '<em>Cmr Field Type Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cmr Field Type Type</em>'.
	 * @generated
	 */
	CmrFieldTypeType createCmrFieldTypeType();

	/**
	 * Returns a new object of class '<em>Container Transaction Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Container Transaction Type</em>'.
	 * @generated
	 */
	ContainerTransactionType createContainerTransactionType();

	/**
	 * Returns a new object of class '<em>Description Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Description Type</em>'.
	 * @generated
	 */
	DescriptionType createDescriptionType();

	/**
	 * Returns a new object of class '<em>Destination Type Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Destination Type Type</em>'.
	 * @generated
	 */
	DestinationTypeType createDestinationTypeType();

	/**
	 * Returns a new object of class '<em>Display Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Display Name Type</em>'.
	 * @generated
	 */
	DisplayNameType createDisplayNameType();

	/**
	 * Returns a new object of class '<em>Document Root</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Document Root</em>'.
	 * @generated
	 */
	DocumentRoot createDocumentRoot();

	/**
	 * Returns a new object of class '<em>Ejb Class Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Class Type</em>'.
	 * @generated
	 */
	EjbClassType createEjbClassType();

	/**
	 * Returns a new object of class '<em>Ejb Client Jar Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Client Jar Type</em>'.
	 * @generated
	 */
	EjbClientJarType createEjbClientJarType();

	/**
	 * Returns a new object of class '<em>Ejb Jar Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Jar Type</em>'.
	 * @generated
	 */
	EjbJarType createEjbJarType();

	/**
	 * Returns a new object of class '<em>Ejb Link Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Link Type</em>'.
	 * @generated
	 */
	EjbLinkType createEjbLinkType();

	/**
	 * Returns a new object of class '<em>Ejb Local Ref Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Local Ref Type</em>'.
	 * @generated
	 */
	EjbLocalRefType createEjbLocalRefType();

	/**
	 * Returns a new object of class '<em>Ejb Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Name Type</em>'.
	 * @generated
	 */
	EjbNameType createEjbNameType();

	/**
	 * Returns a new object of class '<em>Ejb Ql Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Ql Type</em>'.
	 * @generated
	 */
	EjbQlType createEjbQlType();

	/**
	 * Returns a new object of class '<em>Ejb Ref Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Ref Name Type</em>'.
	 * @generated
	 */
	EjbRefNameType createEjbRefNameType();

	/**
	 * Returns a new object of class '<em>Ejb Ref Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Ref Type</em>'.
	 * @generated
	 */
	EjbRefType createEjbRefType();

	/**
	 * Returns a new object of class '<em>Ejb Ref Type Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Ref Type Type</em>'.
	 * @generated
	 */
	EjbRefTypeType createEjbRefTypeType();

	/**
	 * Returns a new object of class '<em>Ejb Relation Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Relation Name Type</em>'.
	 * @generated
	 */
	EjbRelationNameType createEjbRelationNameType();

	/**
	 * Returns a new object of class '<em>Ejb Relationship Role Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Relationship Role Name Type</em>'.
	 * @generated
	 */
	EjbRelationshipRoleNameType createEjbRelationshipRoleNameType();

	/**
	 * Returns a new object of class '<em>Ejb Relationship Role Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Relationship Role Type</em>'.
	 * @generated
	 */
	EjbRelationshipRoleType createEjbRelationshipRoleType();

	/**
	 * Returns a new object of class '<em>Ejb Relation Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ejb Relation Type</em>'.
	 * @generated
	 */
	EjbRelationType createEjbRelationType();

	/**
	 * Returns a new object of class '<em>Enterprise Beans Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Enterprise Beans Type</em>'.
	 * @generated
	 */
	EnterpriseBeansType createEnterpriseBeansType();

	/**
	 * Returns a new object of class '<em>Entity Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Entity Type</em>'.
	 * @generated
	 */
	EntityType createEntityType();

	/**
	 * Returns a new object of class '<em>Env Entry Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Env Entry Name Type</em>'.
	 * @generated
	 */
	EnvEntryNameType createEnvEntryNameType();

	/**
	 * Returns a new object of class '<em>Env Entry Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Env Entry Type</em>'.
	 * @generated
	 */
	EnvEntryType createEnvEntryType();

	/**
	 * Returns a new object of class '<em>Env Entry Type Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Env Entry Type Type</em>'.
	 * @generated
	 */
	EnvEntryTypeType createEnvEntryTypeType();

	/**
	 * Returns a new object of class '<em>Env Entry Value Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Env Entry Value Type</em>'.
	 * @generated
	 */
	EnvEntryValueType createEnvEntryValueType();

	/**
	 * Returns a new object of class '<em>Exclude List Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Exclude List Type</em>'.
	 * @generated
	 */
	ExcludeListType createExcludeListType();

	/**
	 * Returns a new object of class '<em>Field Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Field Name Type</em>'.
	 * @generated
	 */
	FieldNameType createFieldNameType();

	/**
	 * Returns a new object of class '<em>Home Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Home Type</em>'.
	 * @generated
	 */
	HomeType createHomeType();

	/**
	 * Returns a new object of class '<em>Large Icon Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Large Icon Type</em>'.
	 * @generated
	 */
	LargeIconType createLargeIconType();

	/**
	 * Returns a new object of class '<em>Local Home Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Local Home Type</em>'.
	 * @generated
	 */
	LocalHomeType createLocalHomeType();

	/**
	 * Returns a new object of class '<em>Local Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Local Type</em>'.
	 * @generated
	 */
	LocalType createLocalType();

	/**
	 * Returns a new object of class '<em>Message Driven Destination Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Message Driven Destination Type</em>'.
	 * @generated
	 */
	MessageDrivenDestinationType createMessageDrivenDestinationType();

	/**
	 * Returns a new object of class '<em>Message Driven Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Message Driven Type</em>'.
	 * @generated
	 */
	MessageDrivenType createMessageDrivenType();

	/**
	 * Returns a new object of class '<em>Message Selector Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Message Selector Type</em>'.
	 * @generated
	 */
	MessageSelectorType createMessageSelectorType();

	/**
	 * Returns a new object of class '<em>Method Intf Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Method Intf Type</em>'.
	 * @generated
	 */
	MethodIntfType createMethodIntfType();

	/**
	 * Returns a new object of class '<em>Method Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Method Name Type</em>'.
	 * @generated
	 */
	MethodNameType createMethodNameType();

	/**
	 * Returns a new object of class '<em>Method Params Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Method Params Type</em>'.
	 * @generated
	 */
	MethodParamsType createMethodParamsType();

	/**
	 * Returns a new object of class '<em>Method Param Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Method Param Type</em>'.
	 * @generated
	 */
	MethodParamType createMethodParamType();

	/**
	 * Returns a new object of class '<em>Method Permission Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Method Permission Type</em>'.
	 * @generated
	 */
	MethodPermissionType createMethodPermissionType();

	/**
	 * Returns a new object of class '<em>Method Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Method Type</em>'.
	 * @generated
	 */
	MethodType createMethodType();

	/**
	 * Returns a new object of class '<em>Multiplicity Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Multiplicity Type</em>'.
	 * @generated
	 */
	MultiplicityType createMultiplicityType();

	/**
	 * Returns a new object of class '<em>Persistence Type Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Persistence Type Type</em>'.
	 * @generated
	 */
	PersistenceTypeType createPersistenceTypeType();

	/**
	 * Returns a new object of class '<em>Prim Key Class Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Prim Key Class Type</em>'.
	 * @generated
	 */
	PrimKeyClassType createPrimKeyClassType();

	/**
	 * Returns a new object of class '<em>Primkey Field Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Primkey Field Type</em>'.
	 * @generated
	 */
	PrimkeyFieldType createPrimkeyFieldType();

	/**
	 * Returns a new object of class '<em>Query Method Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Query Method Type</em>'.
	 * @generated
	 */
	QueryMethodType createQueryMethodType();

	/**
	 * Returns a new object of class '<em>Query Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Query Type</em>'.
	 * @generated
	 */
	QueryType createQueryType();

	/**
	 * Returns a new object of class '<em>Reentrant Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Reentrant Type</em>'.
	 * @generated
	 */
	ReentrantType createReentrantType();

	/**
	 * Returns a new object of class '<em>Relationship Role Source Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Relationship Role Source Type</em>'.
	 * @generated
	 */
	RelationshipRoleSourceType createRelationshipRoleSourceType();

	/**
	 * Returns a new object of class '<em>Relationships Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Relationships Type</em>'.
	 * @generated
	 */
	RelationshipsType createRelationshipsType();

	/**
	 * Returns a new object of class '<em>Remote Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Remote Type</em>'.
	 * @generated
	 */
	RemoteType createRemoteType();

	/**
	 * Returns a new object of class '<em>Res Auth Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Res Auth Type</em>'.
	 * @generated
	 */
	ResAuthType createResAuthType();

	/**
	 * Returns a new object of class '<em>Resource Env Ref Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Resource Env Ref Name Type</em>'.
	 * @generated
	 */
	ResourceEnvRefNameType createResourceEnvRefNameType();

	/**
	 * Returns a new object of class '<em>Resource Env Ref Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Resource Env Ref Type</em>'.
	 * @generated
	 */
	ResourceEnvRefType createResourceEnvRefType();

	/**
	 * Returns a new object of class '<em>Resource Env Ref Type Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Resource Env Ref Type Type</em>'.
	 * @generated
	 */
	ResourceEnvRefTypeType createResourceEnvRefTypeType();

	/**
	 * Returns a new object of class '<em>Resource Ref Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Resource Ref Type</em>'.
	 * @generated
	 */
	ResourceRefType createResourceRefType();

	/**
	 * Returns a new object of class '<em>Res Ref Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Res Ref Name Type</em>'.
	 * @generated
	 */
	ResRefNameType createResRefNameType();

	/**
	 * Returns a new object of class '<em>Res Sharing Scope Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Res Sharing Scope Type</em>'.
	 * @generated
	 */
	ResSharingScopeType createResSharingScopeType();

	/**
	 * Returns a new object of class '<em>Res Type Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Res Type Type</em>'.
	 * @generated
	 */
	ResTypeType createResTypeType();

	/**
	 * Returns a new object of class '<em>Result Type Mapping Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Result Type Mapping Type</em>'.
	 * @generated
	 */
	ResultTypeMappingType createResultTypeMappingType();

	/**
	 * Returns a new object of class '<em>Role Link Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Role Link Type</em>'.
	 * @generated
	 */
	RoleLinkType createRoleLinkType();

	/**
	 * Returns a new object of class '<em>Role Name Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Role Name Type</em>'.
	 * @generated
	 */
	RoleNameType createRoleNameType();

	/**
	 * Returns a new object of class '<em>Run As Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Run As Type</em>'.
	 * @generated
	 */
	RunAsType createRunAsType();

	/**
	 * Returns a new object of class '<em>Security Identity Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Security Identity Type</em>'.
	 * @generated
	 */
	SecurityIdentityType createSecurityIdentityType();

	/**
	 * Returns a new object of class '<em>Security Role Ref Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Security Role Ref Type</em>'.
	 * @generated
	 */
	SecurityRoleRefType createSecurityRoleRefType();

	/**
	 * Returns a new object of class '<em>Security Role Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Security Role Type</em>'.
	 * @generated
	 */
	SecurityRoleType createSecurityRoleType();

	/**
	 * Returns a new object of class '<em>Session Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Session Type</em>'.
	 * @generated
	 */
	SessionType createSessionType();

	/**
	 * Returns a new object of class '<em>Session Type Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Session Type Type</em>'.
	 * @generated
	 */
	SessionTypeType createSessionTypeType();

	/**
	 * Returns a new object of class '<em>Small Icon Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Small Icon Type</em>'.
	 * @generated
	 */
	SmallIconType createSmallIconType();

	/**
	 * Returns a new object of class '<em>Subscription Durability Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Subscription Durability Type</em>'.
	 * @generated
	 */
	SubscriptionDurabilityType createSubscriptionDurabilityType();

	/**
	 * Returns a new object of class '<em>Transaction Type Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Transaction Type Type</em>'.
	 * @generated
	 */
	TransactionTypeType createTransactionTypeType();

	/**
	 * Returns a new object of class '<em>Trans Attribute Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Trans Attribute Type</em>'.
	 * @generated
	 */
	TransAttributeType createTransAttributeType();

	/**
	 * Returns a new object of class '<em>Unchecked Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Unchecked Type</em>'.
	 * @generated
	 */
	UncheckedType createUncheckedType();

	/**
	 * Returns a new object of class '<em>Use Caller Identity Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Use Caller Identity Type</em>'.
	 * @generated
	 */
	UseCallerIdentityType createUseCallerIdentityType();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	EjbJar20Package getEjbJar20Package();

} //EjbJar20Factory
